/********************************************************************
*  File: calcL.c
*
*  Description:
*	
*	First step of an Gaus-Seidel elimination. The lower left values of 
*   the input Matrix are set to zero. The following example values aren't correct
*
*   1   2   1   | ...                1   2   1  |  ...
*   2   3   1   | ...        =>      0   2   1  |  ...
*   1   1   2   | ...                0   0   1  |  ...
*   Inputmatrix                          E         
*
*
*  Arguments: 
*	- float *matrix       Input Matrix 1D
*   - int size            Matrix dimension in size
*   - int stride          Matrix dimenstion + dimension of entity matrix
*	
* Used custom Routines:
*	- 
*
*********************************************************************/


#include "../Header/CPUGausSeidel.h"

int calcL (float *matrix, int size, int stride)
{
    int i, j, k;

    float *maPivTemp = matrix;

    //loop over cols
    for (i = 0; i < size; i++)
    {
        //loop over each row
        for (j = i + 1; j < size; j++)
        {
            float pivoEl;
            float *maRowTemp = matrix + (j * stride);

            if (maPivTemp[i] == 0)
            {
                pivoEl = 0;
            }
            else
            {
                pivoEl = maRowTemp[i] / maPivTemp[i];
            }

            //loop through the col and sub the pivot element
            for (k = 0; k < stride; k++)
            {
                maRowTemp[k] -= maPivTemp[k] * pivoEl;
            }
        }
        maPivTemp += stride;
    }
    return 0;
}
