/********************************************************************
*  File: calcR.c
*
*  Description:
*	
*	Second step of an Gaus-Seidel elimination. The upper right values of 
*   the input Matrix are set to zero. The following example values aren't correct
*
*   1   5   1   | ...                1   0   0  |  ...
*   0   3   1   | ...        =>      0   2   0  |  ...
*   0   0   2   | ...                0   0   1  |  ...
*   Inputmatrix                          E         
*
*
*  Arguments: 
*	- float *matrix       Input Matrix 1D
*   - int size            Matrix dimension in size
*   - int stride          Matrix dimenstion + dimension of entity matrix
*	
* Used custom Routines:
*	- 
*
*********************************************************************/


#include "../Header/CPUGausSeidel.h"

int calcR (float *matrix, int size, int stride)
{
    int i, j, k;

    //ptr to the last row
    float *maPivTemp = matrix + stride * (size - 1);

    //loop over cols
    for (i = (size - 1); i > 0; i--)
    {
        //loop over each row
        for (j = 0; j < i; j++)
        {
            float pivoEl;
            float *maRowTemp = matrix + (j * stride);

            if (maPivTemp[i] == 0)
            {
                pivoEl = 0;
            }
            else
            {
                pivoEl = maRowTemp[i] / maPivTemp[i];
            }

            //loop through the col and sub the pivot element
            for (k = 0; k < stride; k++)
            {
                maRowTemp[k] -= maPivTemp[k] * pivoEl;
            }
        }
        maPivTemp -= stride;
    }
    return 0;
}
