/********************************************************************
*  File: normalizeDiag.c
*
*  Description:
*	
*   Last step of Gaus-Seidel Algorithm.
*	Force the entries of diagonal matrix to 1 to get a
*   left sided entity matrix.
*
*   1   0   0   | ...                1   0   0  |  ...
*   0   3   0   | ...        =>      0   1   0  |  .(Result).
*   0   0   2   | ...                0   0   1  |  ...
*   Inputmatrix                          E         
*
*
*  Arguments: 
*	- float *matrix       Input Matrix 1D
*   - int size            Matrix dimension in size
*   - int stride          Matrix dimenstion + dimension of entity matrix
*	
* Used custom Routines:
*	- 
*
*********************************************************************/
#include "../Header/CPUGausSeidel.h"

void normalizeDiag (float *matrix, int size, int stride)
{
    int i, j;

    for (i = 0; i < size; i++)
    {
        float val = matrix[i];

        for (j = 0; j < stride; j++)
        {
            matrix[j] /= val;
        }
        matrix += stride;
    }
}
