/********************************************************************
*  File: normalizeDiag.c
*
*  Description:
*	
*   Pad the entity matrix to the inputmatrix
*
*   1   1   2                  1   1   2  |  1  0   0
*   8   3   2          =>      8   3   2  |  0  1   0
*   2   1   3                  2   1   3  |  0  0   1
*   Inputmatrix                                 E         
*
*
*  Arguments: 
*	- float *src          Input Matrix 1D
*	- float *dest         Outputmatrix like (Inputmatrix | Entitymatrix) 
*   - int size            Matrix dimension in size
*   - int stride          Matrix dimenstion + dimension of entity matrix
*	
* Used custom Routines:
*	- 
*
*********************************************************************/
#include <memory.h>

#include "../Header/CPUGausSeidel.h"

void padDiag (float* src, 
              float* dest, 
              int size, 
              int stride)
{
    int i;

    for (i = 0; i < size; i++)
    {
        memcpy (dest, src, size * sizeof (float));
        memset(dest + size, 0, size * sizeof (float));
        dest[i + size] = 1;
        dest += stride;
        src += size;
    }
}